<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '../../../plugins/contentful';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { assemblePageContent } from '~/services/jobs/all-jobs.service';
import { NextStepAlt } from '~/components/common/index.vue';

import JobsHero from '~/components/jobs/jobs-hero.vue';
import JobsControls from '~/components/jobs/jobs-controls.vue';
import JobsCta from '~/components/jobs/jobs-cta.vue';

export default Vue.extend({
  name: 'AllJobsPage',
  components: {
    JobsHero,
    JobsControls,
    JobsCta,
    NextStepAlt,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '5oCKZ6Szkbo1CF3QlpFZQn',
        include: 10,
      });
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;

      const pageContent = assemblePageContent(items);

      return { items, pageContent, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      greenhouseData: [],
      content: [],
    };
  },

  head(): MetaInfo {
    return getPageMetadata(
      (this as any).pageContent.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  created() {
    this.content = this.pageContent.components.completeDivisionsList;
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.pageContent = assemblePageContent(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div>
    <component
      :is="component.name"
      v-for="component in pageContent.components"
      :key="component.name"
      :data="component.data"
    />
    <NextStepAlt v-if="pageContent.nextStepsVariant" />
  </div>
</template>
